<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: HttpResponse.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">HttpResponse.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * HttpResponse.h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Encapsulate a response to be sent to the Http client.</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> *  Created on: Sep 2, 2017</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *      Author: kolban</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;</div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#ifndef COMPONENTS_CPP_UTILS_HTTPRESPONSE_H_</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#define COMPONENTS_CPP_UTILS_HTTPRESPONSE_H_</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;map&gt;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &quot;HttpRequest.h&quot;</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno"><a class="line" href="classHttpResponse.html">   16</a></span>&#160;<span class="keyword">class </span><a class="code" href="classHttpResponse.html">HttpResponse</a> {</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> HTTP_STATUS_CONTINUE;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> HTTP_STATUS_SWITCHING_PROTOCOL;</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> HTTP_STATUS_OK;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> HTTP_STATUS_MOVED_PERMANENTLY;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> HTTP_STATUS_BAD_REQUEST;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> HTTP_STATUS_UNAUTHORIZED;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> HTTP_STATUS_FORBIDDEN;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> HTTP_STATUS_NOT_FOUND;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> HTTP_STATUS_METHOD_NOT_ALLOWED;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> HTTP_STATUS_INTERNAL_SERVER_ERROR;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> HTTP_STATUS_NOT_IMPLEMENTED;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> HTTP_STATUS_SERVICE_UNAVAILABLE;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <a class="code" href="classHttpResponse.html">HttpResponse</a>(<a class="code" href="classHttpRequest.html">HttpRequest</a>* httpRequest);</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="keyword">virtual</span> ~<a class="code" href="classHttpResponse.html">HttpResponse</a>();</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="keywordtype">void</span>                               <a class="code" href="classHttpResponse.html#a6a83c668bb537a24f3e62255501fb25e">addHeader</a>(std::string name, std::string value);  <span class="comment">// Add a header to be sent to the client.</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keywordtype">void</span>                               <a class="code" href="classHttpResponse.html#a9fa95070f1861a24558f4a63f6d87818">close</a>();                                         <span class="comment">// Close the request/response.</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    std::string                        <a class="code" href="classHttpResponse.html#ab76b0ba3926f6ddd0396b9cbe75c8cfe">getHeader</a>(std::string name);                     <span class="comment">// Get a named header.</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    std::map&lt;std::string, std::string&gt; getHeaders();                                    <span class="comment">// Get all headers.</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keywordtype">void</span>                               <a class="code" href="classHttpResponse.html#a68bc032812a96326d9fe4fde668a372b">sendData</a>(std::string data);                      <span class="comment">// Send data to the client.</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keywordtype">void</span>                               <a class="code" href="classHttpResponse.html#a68bc032812a96326d9fe4fde668a372b">sendData</a>(uint8_t* pData, <span class="keywordtype">size_t</span> size);           <span class="comment">// Send data to the client.</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keywordtype">void</span>                               <a class="code" href="classHttpResponse.html#af13a61ae987f15599232fa30d2cfdeab">setStatus</a>(<span class="keywordtype">int</span> status, std::string message);      <span class="comment">// Set the response status.</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keywordtype">void</span>                               sendFile(std::string fileName, <span class="keywordtype">size_t</span> bufSize = 4 * 1024);   <span class="comment">// Send file contents if exists.</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keywordtype">bool</span>                               m_headerCommitted;  <span class="comment">// Has the header been sent?</span></div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <a class="code" href="classHttpRequest.html">HttpRequest</a>*                       m_request;         <span class="comment">// The request associated with this response.</span></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    std::map&lt;std::string, std::string&gt; m_responseHeaders;  <span class="comment">// The headers to be sent with the response.</span></div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keywordtype">int</span>                             m_status;          <span class="comment">// The status to be sent with the response.</span></div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    std::string                     m_statusMessage;    <span class="comment">// The status message to be sent with the response.</span></div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keywordtype">void</span> sendHeader();                                   <span class="comment">// Send the header to the client.</span></div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;};</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* COMPONENTS_CPP_UTILS_HTTPRESPONSE_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="classHttpResponse_html_af13a61ae987f15599232fa30d2cfdeab"><div class="ttname"><a href="classHttpResponse.html#af13a61ae987f15599232fa30d2cfdeab">HttpResponse::setStatus</a></div><div class="ttdeci">void setStatus(int status, std::string message)</div><div class="ttdoc">Set the status code that is to be sent back to the client. When a client makes a request,...</div><div class="ttdef"><b>Definition:</b> HttpResponse.cpp:179</div></div>
<div class="ttc" id="classHttpResponse_html_ab76b0ba3926f6ddd0396b9cbe75c8cfe"><div class="ttname"><a href="classHttpResponse.html#ab76b0ba3926f6ddd0396b9cbe75c8cfe">HttpResponse::getHeader</a></div><div class="ttdeci">std::string getHeader(std::string name)</div><div class="ttdoc">Get the value of the named header.</div><div class="ttdef"><b>Definition:</b> HttpResponse.cpp:71</div></div>
<div class="ttc" id="classHttpResponse_html_a68bc032812a96326d9fe4fde668a372b"><div class="ttname"><a href="classHttpResponse.html#a68bc032812a96326d9fe4fde668a372b">HttpResponse::sendData</a></div><div class="ttdeci">void sendData(std::string data)</div><div class="ttdoc">Send data to the partner. Send some data to the partner. If we haven't yet sent the HTTP header then ...</div><div class="ttdef"><b>Definition:</b> HttpResponse.cpp:88</div></div>
<div class="ttc" id="classHttpResponse_html_a6a83c668bb537a24f3e62255501fb25e"><div class="ttname"><a href="classHttpResponse.html#a6a83c668bb537a24f3e62255501fb25e">HttpResponse::addHeader</a></div><div class="ttdeci">void addHeader(std::string name, std::string value)</div><div class="ttdoc">Add a header to the response message. If the response has already been committed then ignore this req...</div><div class="ttdef"><b>Definition:</b> HttpResponse.cpp:46</div></div>
<div class="ttc" id="classHttpRequest_html"><div class="ttname"><a href="classHttpRequest.html">HttpRequest</a></div><div class="ttdef"><b>Definition:</b> HttpRequest.h:19</div></div>
<div class="ttc" id="classHttpResponse_html_a9fa95070f1861a24558f4a63f6d87818"><div class="ttname"><a href="classHttpResponse.html#a9fa95070f1861a24558f4a63f6d87818">HttpResponse::close</a></div><div class="ttdeci">void close()</div><div class="ttdoc">Close the response. We close the response. If we haven't yet sent the header, we send that now and th...</div><div class="ttdef"><b>Definition:</b> HttpResponse.cpp:57</div></div>
<div class="ttc" id="classHttpResponse_html"><div class="ttname"><a href="classHttpResponse.html">HttpResponse</a></div><div class="ttdef"><b>Definition:</b> HttpResponse.h:16</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
